﻿//-----------------------------------------------
//TUSB-0212ADM2用ドライバアクセス用API
//Visual C# 用モジュール
//
//2013_10_30　株式会社タートル工業
//Copyright (C) 2013 Turtle Industry Co.,Ltd.
//-----------------------------------------------

using System.Runtime.InteropServices;


class TUSBADM2
{
    [DllImport("TUSBADM2.DLL", CallingConvention = CallingConvention.Cdecl)]
    public static extern short Tusbadm2_Device_Open( short id);
    [DllImport("TUSBADM2.DLL", CallingConvention = CallingConvention.Cdecl)]
    public static extern void Tusbadm2_Device_Close( short id);
    [DllImport("TUSBADM2.DLL", CallingConvention = CallingConvention.Cdecl)]
    public static extern short Tusbadm2_Dio_Read( short id, out byte Data);
    [DllImport("TUSBADM2.DLL", CallingConvention = CallingConvention.Cdecl)]
    public static extern short Tusbadm2_Dio_Write( short id, byte Data);
    [DllImport("TUSBADM2.DLL", CallingConvention = CallingConvention.Cdecl)]
    public static extern short Tusbadm2_Adc_Start( short id, int CycLen, int PreLen, byte TrgSel, byte Mode, byte Ch1Only);
    [DllImport("TUSBADM2.DLL", CallingConvention = CallingConvention.Cdecl)]
    public static extern short Tusbadm2_Adc_Stop( short id);
    [DllImport("TUSBADM2.DLL", CallingConvention = CallingConvention.Cdecl)]
    public static extern short Tusbadm2_Status_Get( short id, out byte Status, out byte OvfStShort);
    [DllImport("TUSBADM2.DLL", CallingConvention = CallingConvention.Cdecl)]
    public static extern short Tusbadm2_Length( short id, out int Len1, out int Len2, out int Rate1, out int Rate2 );
    [DllImport("TUSBADM2.DLL", CallingConvention = CallingConvention.Cdecl)]
    public static extern short Tusbadm2_Data_Get( short id, byte ch, [Out] short[] Data,ref int Leng);
    [DllImport("TUSBADM2.DLL", CallingConvention = CallingConvention.Cdecl)]
    public static extern short Tusbadm2_Clock_Select( short id, byte InExt, byte Inv, short Div);
    [DllImport("TUSBADM2.DLL", CallingConvention = CallingConvention.Cdecl)]
    public static extern short Tusbadm2_ThLevel_Set( short id, short ThLevel, short NLevel);
    [DllImport("TUSBADM2.DLL", CallingConvention = CallingConvention.Cdecl)]
    public static extern short Tusbadm2_InputType( short id, byte Type1, byte Type2 );
    [DllImport("TUSBADM2.DLL", CallingConvention = CallingConvention.Cdecl)]
    public static extern short Tusbadm2_CheckInputType( short id, out byte Type1, out byte Type2 );
    [DllImport("TUSBADM2.DLL", CallingConvention = CallingConvention.Cdecl)]
    public static extern short Tusbadm2_Trigger(short id);
    [DllImport("TUSBADM2.DLL", CallingConvention = CallingConvention.Cdecl)]
    public static extern short Tusbadm2_TransLimit(short id,int Limit);

    public static string GetErrMessage(short retcode)
    {
        switch (retcode)
        {
            case 0:
                return "正常終了しました";
            case 1:
                return "ID番号が不正です";
            case 2:
                return "ドライバがインストールされていません";
            case 3:
                return "すでにデバイスはオープンされています";
            case 4:
                return "接続されている台数が多すぎます";
            case 5:
                return "オープンできませんでした";
            case 6:
                return "デバイスがみつかりません";
            case 7:
                return "オープンされていません";
            case 8:
                return "パラメータエラー";
            case 9:
                return "USB通信エラーです";
            default:
                return "不明なエラーです";
        }
    }
}

