﻿Imports System.IO

Public Class DevForm
    Public DevId As Short 'Device Id
    Private SmplMaxLeng As Integer '最大取り込み長
    Private SaveFile(1) As BinaryWriter ' 保存ファイルストリーム
    Private SavedDataNum(1) As Integer
    'サンプリング条件----------------------------------
    Private InExt As Byte 'クロック選択 0:内部　1:外部
    Private ClkDivN As Integer '内部クロック分周率 n=2～5000
    Private ClkInv As Byte 'Ch2クロック反転　0:なし 1:あり
    Private TrgSel As Byte 'トリガ選択 0:外部 1:立ち上がり 2:立下り 3:ソフトウェア
    Private Threshold As Integer 'アナログトリガ閾値f
    Private NoiseCancel As Integer 'ノイズキャンセルレベル

    '自然数かどうか判定する関数
    Private Function IsNatural(ByRef strNum As String) As Boolean
        If (Len(strNum) = 0) Then 'string length 0
            Return False
        End If

        If Not (strNum Like "*[!0-9]*") Then 'Charactor check [0-9]
            Return True
        Else
            Return False
        End If
    End Function

    'DevFormの初期化を行う
    Public Sub SetId(ByVal Id As Short)
        Dim retErr As Short 'return error
        Dim IOData As Byte '
        Dim Type1 As Byte
        Dim Type2 As Byte

        DevId = Id

        Me.Text = "ID = " & CStr(DevId) & "  Panel"
        retErr = Tusbadm2_Dio_Read(DevId, IOData) 'Read digital I/O
        If retErr <> 0 Then
            Tusbadm2_ErrorDisp(retErr)
            Me.Hide()
            Exit Sub
        Else
            'Output state
            DOChk3.Checked = IIf(IOData And &H80S, True, False)
            DOChk2.Checked = IIf(IOData And &H80S, True, False)
            DOChk1.Checked = IIf(IOData And &H80S, True, False)
            DOChk0.Checked = IIf(IOData And &H80S, True, False)

            'Input State
            DIDisp3.Text = IIf(IOData And &H8S, "High", "Low")
            DIDisp2.Text = IIf(IOData And &H4S, "High", "Low")
            DIDisp1.Text = IIf(IOData And &H2S, "High", "Low")
            DIDisp0.Text = IIf(IOData And &H1S, "High", "Low")
        End If

        ClockSel1.Checked = True
        DivideN.Text = CStr(2)
        DivideN_Change()

        retErr = Tusbadm2_CheckInputType(DevId, Type1, Type2) 'Read input range
        If retErr <> 0 Then
            Tusbadm2_ErrorDisp(retErr)
            Me.Hide()
            Exit Sub
        Else
            If Type1 Then
                Ch1InputSel1.Checked = True
            Else
                Ch1InputSel2.Checked = True
            End If
            If Type2 Then
                Ch2InputSel1.Checked = True
            Else
                Ch2InputSel2.Checked = True
            End If
        End If

        TrgSel4.Checked = True 'Select soft trigger
        TrgSet()
        ThLevel.Text = "2048" 'Select center of range
        NCLevel.Text = "102" '50mV
        SmplMode2.Checked = True 'Continuation mode
        CycleLeng.Text = "1000" 'Sampling length per one trigger. (1～1,048,576)
        PreTrgLeng.Text = "0" 'Pre trigger length. (0～1,048,576)
        TotalLeng.Text = "100000" 'Total sampling length.  (1～2,000,000,000)

        Timer1.Interval = 100
        Timer1.Enabled = True
    End Sub

    'DevFormが閉じられる時に実行されます
    Private Sub DevForm_FormClosed(sender As System.Object, e As System.Windows.Forms.FormClosedEventArgs) Handles MyBase.FormClosed
        If Timer2.Enabled Then 'タイマー2が動作中であれば
            Timer2.Enabled = False
            StartStop(False) '停止
        End If
        Timer1.Enabled = False 'タイマー1を停止します
    End Sub

    'ディジタル出力設定
    Private Sub DO_Set()
        Dim retErr As Short
        Dim OutData As Byte

        OutData = 0

        If DOChk0.Checked Then 'ビット0
            OutData = OutData + &H1S
        End If
        If DOChk1.Checked Then 'ビット1
            OutData = OutData + &H2S
        End If
        If DOChk2.Checked Then 'ビット2
            OutData = OutData + &H4S
        End If
        If DOChk3.Checked Then 'ビット3
            OutData = OutData + &H8S
        End If

        retErr = Tusbadm2_Dio_Write(DevId, OutData) '設定
        If retErr <> 0 Then
            Tusbadm2_ErrorDisp(retErr)
            Me.Hide()
            Exit Sub
        End If
    End Sub

    Private Sub DOChk_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles DOChk3.CheckedChanged, DOChk2.CheckedChanged, DOChk1.CheckedChanged, DOChk0.CheckedChanged
        DO_Set()
        DOChk0.Text = IIf(DOChk0.Checked, "High", "Low")
        DOChk1.Text = IIf(DOChk1.Checked, "High", "Low")
        DOChk2.Text = IIf(DOChk2.Checked, "High", "Low")
        DOChk3.Text = IIf(DOChk3.Checked, "High", "Low")
    End Sub

    'ディジタル入力チェック
    Private Sub DI_Check()
        Dim IOData As Byte
        Dim retErr As Short

        retErr = Tusbadm2_Dio_Read(DevId, IOData)
        If retErr <> 0 Then
            Tusbadm2_ErrorDisp(retErr)
            Me.Hide()
            Exit Sub
        Else
            '入力状態
            DIDisp3.Text = IIf(IOData And &H8S, "High", "Low") 'ビット3
            DIDisp2.Text = IIf(IOData And &H4S, "High", "Low") 'ビット2
            DIDisp1.Text = IIf(IOData And &H2S, "High", "Low") 'ビット1
            DIDisp0.Text = IIf(IOData And &H1S, "High", "Low") 'ビット0
        End If
    End Sub

    Private Sub Timer1_Tick(sender As System.Object, e As System.EventArgs) Handles Timer1.Tick
        DI_Check()
    End Sub

    Private Sub ClockSel_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles ClockSel1.CheckedChanged, ClockSel2.CheckedChanged
        If ClockSel1.Checked Then
            DivideN.Enabled = True '内部クロックを選択
        Else
            DivideN.Enabled = False '外部クロックを選択
        End If
    End Sub

    Private Sub DivideN_Change()
        Dim DivN As Integer

        If IsNatural((DivideN.Text)) Then
            DivN = CInt(DivideN.Text)
            If DivN < 2 Then '2未満は範囲外
                IntClockFreq.Text = ""
            ElseIf DivN <= 50 Then  '1MHz以上
                IntClockFreq.Text = (50.0 / DivN).ToString("0.0000") & "MHz"
            ElseIf DivN <= 5000 Then  '10kHz～1MHz前まで
                IntClockFreq.Text = (50000.0# / DivN).ToString("0.000") & "kHz"
            Else '範囲外
                IntClockFreq.Text = ""
            End If
        End If
    End Sub
    Private Sub DivideN_TextChanged(sender As System.Object, e As System.EventArgs) Handles DivideN.TextChanged
        DivideN_Change()
    End Sub

    '入力レンジ選択
    Private Sub SetInputType()
        Dim retErr As Short
        Dim Type1 As Byte
        Dim Type2 As Byte

        Type1 = IIf(Ch1InputSel1.Checked, 1, 0) 'ch1 0:unipolar 1:bipolar
        Type2 = IIf(Ch2InputSel1.Checked, 1, 0) 'ch2 0:unipolar 1:bipolar

        retErr = Tusbadm2_InputType(DevId, Type1, Type2) 'Set input range
        If retErr <> 0 Then
            Tusbadm2_ErrorDisp(retErr)
            Me.Hide()
            Exit Sub
        End If
    End Sub

    Private Sub Ch1InputSel_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles Ch1InputSel1.CheckedChanged, Ch1InputSel2.CheckedChanged
        SetInputType()
        ThLevelChange()
    End Sub

    Private Sub Ch2InputSel_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles Ch2InputSel1.CheckedChanged, Ch2InputSel2.CheckedChanged
        SetInputType()
    End Sub

    'トリガ選択による有効コントロールの処理
    Private Sub TrgSet()
        ThLevel.Enabled = IIf(TrgSel1.Checked Or TrgSel4.Checked, False, True)
        NCLevel.Enabled = IIf(TrgSel1.Checked Or TrgSel4.Checked, False, True)
        TriggerBtn.Enabled = IIf(TrgSel4.Checked, True, False)
    End Sub

    Private Sub TrgSel_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles TrgSel4.CheckedChanged, TrgSel3.CheckedChanged, TrgSel2.CheckedChanged, TrgSel1.CheckedChanged
        TrgSet()
    End Sub

    'トリガスレッショルドレベルが変わった時の処理
    Private Sub ThLevelChange()
        Dim Level As Integer
        Dim Volt As Double

        If IsNatural((ThLevel.Text)) Then
            Level = CInt(ThLevel.Text)
            If (Level >= 1 And Level <= 4094) Then
                If Ch1InputSel1.Checked Then 'ユニポーラ 0-2V
                    Volt = 2.0# * Level / 4096.0#
                Else 'バイポーラ
                    Volt = 2.0# * Level / 4096.0# - 1.0#
                End If
                ThLevelV.Text = Volt.ToString("0.000") & "[V]"
            Else
                ThLevelV.Text = ""
            End If
        Else
            ThLevelV.Text = ""
        End If
    End Sub

    Private Sub ThLevel_TextChanged(sender As System.Object, e As System.EventArgs) Handles ThLevel.TextChanged
        ThLevelChange()
    End Sub

    'ノイズキャンセルレベル設定値のチェック
    Private Sub NCLevel_TextChanged(sender As System.Object, e As System.EventArgs) Handles NCLevel.TextChanged
        Dim Level As Integer
        Dim Volt As Double

        If IsNatural((NCLevel.Text)) Then '自然数であるか
            Level = CInt(NCLevel.Text)
            If (Level >= 0 And Level <= 205) Then '範囲内であるか
                Volt = 2.0# * Level / 4096.0# * 1000.0#
                NCLevelV.Text = Volt.ToString("0.0") & "[mV]"
            Else
                NCLevelV.Text = ""
            End If
        Else
            NCLevelV.Text = ""
        End If
    End Sub

    Private Sub SmplMode_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles SmplMode1.CheckedChanged, SmplMode2.CheckedChanged
        If SmplMode1.Checked Then 'リピートモードが選択された
            CycleLeng.Enabled = True
            PreTrgLeng.Enabled = False
        Else '連続モードが選択された
            CycleLeng.Enabled = False
            PreTrgLeng.Enabled = True
        End If
    End Sub

    'クロック設定値のチェックと設定
    Private Function ClockCheckAndSet() As Boolean
        Dim retErr As Short

        If ClockSel1.Checked Then '内部クロック
            If IsNatural((DivideN.Text)) Then 'クロック分周率が自然数がどうか
                ClkDivN = CInt(DivideN.Text)
                If ClkDivN < 2 Or ClkDivN > 5000 Then
                    MessageBox.Show("クロックの設定範囲が無効です")
                    Return False
                End If
            Else
                MessageBox.Show("クロック入力の形式が不正です")
                Return False
            End If
            InExt = 0 '内部クロック
        Else
            ClkDivN = 2
            InExt = 1 '外部クロック
        End If

        ClkInv = IIf(Ch2ClkInv.Checked, 1, 0)

        retErr = Tusbadm2_Clock_Select(DevId, InExt, ClkInv, CShort(ClkDivN)) 'クロック設定
        If retErr <> 0 Then
            Tusbadm2_ErrorDisp(retErr)
            Me.Hide()
            Return False
        End If

        Return True
    End Function

    'トリガ条件チェックと設定
    Private Function TriggerCheckAndSet() As Boolean
        Dim retErr As Short

        If TrgSel2.Checked Or TrgSel3.Checked Then 'アナログトリガの場合
            If IsNatural((ThLevel.Text)) Then 'トリガレベルが自然数であるか
                Threshold = CInt(ThLevel.Text)
                If (Threshold < 1 Or Threshold > 4094) Then '範囲の確認
                    MessageBox.Show("アナログトリガレベル設定範囲が正しくありません")
                    Return False
                End If
            Else
                MessageBox.Show("アナログトリガレベル設定値が不正です")
                Return False
            End If

            If IsNatural((NCLevel.Text)) Then 'ノイズキャンセルレベルが自然数であるか
                NoiseCancel = CInt(NCLevel.Text)
                If (NoiseCancel < 0 Or NoiseCancel > 205) Then '範囲の確認
                    MessageBox.Show("ノイズキャンセル設定範囲が正しくありません")
                    Return False
                End If
            Else
                MessageBox.Show("ノイズキャンセル設定値が不正です")
                Return False
            End If

            retErr = Tusbadm2_ThLevel_Set(DevId, Threshold, NoiseCancel) 'スレッショルドレベル設定
            If retErr <> 0 Then
                Tusbadm2_ErrorDisp(retErr)
                Me.Hide()
                Return False
            End If
        End If

        Return True
    End Function

    '取り込み設定情報書き込み
    Private Sub SaveSamplingSettings(CycLen As Integer, PreLen As Integer, Mode As Byte)
        Dim startTime As System.DateTime '日時
        Dim Type1 As Byte 'ch1 0:ユニポーラ　1:バイポーラ
        Dim Type2 As Byte 'ch2 0:ユニポーラ　1:バイポーラ
        Dim InCh As Byte '入力チャンネル
        startTime = System.DateTime.Now
        Type1 = IIf(Ch1InputSel1.Checked, 1, 0)
        Type2 = IIf(Ch2InputSel1.Checked, 1, 0)

        InCh = 1 'チャンネル1
        SaveFile(0).Write(startTime.ToBinary) '現在日時
        SaveFile(0).Write(InCh) 'チャンネル1
        SaveFile(0).Write(InExt) 'クロック選択 0:内部　1:外部
        SaveFile(0).Write(ClkDivN) '内部クロック分周率 n=2～5000
        SaveFile(0).Write(ClkInv) 'Ch2クロック反転　0:なし 1:あり
        SaveFile(0).Write(Type1) 'ch1 0:ユニポーラ　1:バイポーラ
        SaveFile(0).Write(TrgSel) 'トリガ選択 0:外部 1:立ち上がり 2:立下り 3:ソフトウェア
        SaveFile(0).Write(Threshold) 'アナログトリガ閾値
        SaveFile(0).Write(NoiseCancel) 'ノイズキャンセルレベル
        SaveFile(0).Write(Mode) '取り込み動作モード 0:連続 1:リピート
        SaveFile(0).Write(CycLen) '1トリガ当たりの取り込み長
        SaveFile(0).Write(PreLen) 'プレトリガ長

        If Ch1Only.Checked = 0 Then
            InCh = 2 'チャンネル2
            SaveFile(1).Write(startTime.ToBinary) '現在日時
            SaveFile(1).Write(InCh) 'チャンネル2
            SaveFile(1).Write(InExt) 'クロック選択 0:内部　1:外部
            SaveFile(1).Write(ClkDivN) '内部クロック分周率 n=2～5000
            SaveFile(1).Write(ClkInv) 'Ch2クロック反転　0:なし 1:あり
            SaveFile(1).Write(Type2) 'ch2 0:ユニポーラ　1:バイポーラ
            SaveFile(1).Write(TrgSel) 'トリガ選択 0:外部 1:立ち上がり 2:立下り 3:ソフトウェア
            SaveFile(1).Write(Threshold) 'アナログトリガ閾値
            SaveFile(1).Write(NoiseCancel) 'ノイズキャンセルレベル
            SaveFile(1).Write(Mode) '取り込み動作モード 0:連続 1:リピート
            SaveFile(1).Write(CycLen) '1トリガ当たりの取り込み長
            SaveFile(1).Write(PreLen) 'プレトリガ長
        End If
    End Sub

    '連続変換開始
    Private Function SamplingStart() As Boolean
        Dim retErr As Short
        Dim CycLen As Integer
        Dim PreLen As Integer
        Dim Mode As Byte

        'クロック設定チェック
        If ClockCheckAndSet() = False Then
            Return False
        End If

        'トリガ設定チェック
        If TriggerCheckAndSet() = False Then
            Return False
        End If

        '取り込み数チェック
        If SmplMode1.Checked Then 'リピートモード
            If IsNatural((CycleLeng.Text)) Then
                CycLen = CInt(CycleLeng.Text)
                If (CycLen < 1 Or CycLen > 1048576) Then
                    MessageBox.Show("1トリガ当たりの取り込み長が範囲外です")
                    Return False
                End If
            Else
                MessageBox.Show("1トリガ当たりの取り込み長入力が不正です")
                Return False
            End If
            PreLen = 0
            Mode = 1
        Else '連続モード
            If IsNatural((PreTrgLeng.Text)) Then
                PreLen = CInt(PreTrgLeng.Text)
                If (PreLen < 0 Or PreLen > 1048576) Then
                    MessageBox.Show("プレトリガ長が範囲外です")
                    Return False
                End If
            Else
                MessageBox.Show("プレトリガ長入力が不正です")
                Return False
            End If
            CycLen = 1
            Mode = 0
        End If
        If IsNatural((TotalLeng.Text)) Then
            SmplMaxLeng = CInt(TotalLeng.Text)
            If (SmplMaxLeng < 1 Or SmplMaxLeng > 2000000000) Then
                MessageBox.Show("最大取り込み長が範囲外です")
                Return False
            End If
        Else
            MessageBox.Show("最大取り込み長入力が不正です")
            Return False
        End If

        'トリガ選択
        If TrgSel1.Checked Then
            TrgSel = 0
        ElseIf TrgSel2.Checked Then
            TrgSel = 1
        ElseIf TrgSel3.Checked Then
            TrgSel = 2
        Else
            TrgSel = 3
        End If

        '保存ファイルオープン
        Dim FileName(1) As String

        Do
            OpenFileDialog1.FileName = ""
            OpenFileDialog1.Title = "ADM Ch1 保存ファイル指定"
            OpenFileDialog1.Filter = "バイナリ保存ファイル (*.dat)|*.dat"
            OpenFileDialog1.CheckFileExists = False

            If (OpenFileDialog1.ShowDialog() = Windows.Forms.DialogResult.Cancel) Then
                Return False
            End If
        Loop While OpenFileDialog1.FileName = ""
        FileName(0) = OpenFileDialog1.FileName
        If (File.Exists(FileName(0))) Then '既存ファイルチェツク
            File.Delete(FileName(0))
        End If
        SaveFile(0) = New BinaryWriter(File.OpenWrite(FileName(0))) 'ファイルを開く

        If Ch1Only.Checked = 0 Then
            Do
                OpenFileDialog1.FileName = ""
                OpenFileDialog1.Title = "ADM Ch2 保存ファイル指定"
                OpenFileDialog1.Filter = "バイナリ保存ファイル (*.dat)|*.dat"
                OpenFileDialog1.CheckFileExists = False

                If (OpenFileDialog1.ShowDialog() = Windows.Forms.DialogResult.Cancel) Then
                    Return False
                End If
            Loop While OpenFileDialog1.FileName = "" Or OpenFileDialog1.FileName = FileName(0)
            FileName(1) = OpenFileDialog1.FileName
            If (File.Exists(FileName(1))) Then '既存ファイルチェツク
                File.Delete(FileName(1))
            End If
            SaveFile(1) = New BinaryWriter(File.OpenWrite(FileName(1))) 'ファイルを開く
        End If

        '取り込み設定情報書き込み
        SaveSamplingSettings(CycLen, PreLen, Mode)

        '変換開始
        Dim Ch1OnlyFlg As Byte
        Ch1OnlyFlg = IIf(Ch1Only.Checked, 1, 0)
        retErr = Tusbadm2_Adc_Start(DevId, CycLen, PreLen, TrgSel, Mode, Ch1OnlyFlg) '変換開始
        If retErr <> 0 Then
            Tusbadm2_ErrorDisp(retErr)
            Me.Hide()
            Return False
        End If

        SavedDataNum(0) = 0
        SavedDataNum(1) = 0
        Timer2.Interval = 200
        Timer2.Enabled = True
        Return True
    End Function

    '変換停止
    Private Function SamplingStop() As Boolean
        Dim retErr As Short
        '変換終了
        Timer2.Enabled = False

        retErr = Tusbadm2_Adc_Stop(DevId) '停止

        SaveFile(0).Close()
        SaveFile(1).Close()

        If retErr <> 0 Then
            Tusbadm2_ErrorDisp(retErr)
            Me.Hide()
            Return False
        End If
        Return True
    End Function

    'パネル上のコントロールの有効、無効の設定
    Private Sub EnableDisableControl(ByRef Enable As Boolean)
        ClockSel1.Enabled = Enable
        ClockSel2.Enabled = Enable
        DivideN.Enabled = Enable
        Ch2ClkInv.Enabled = Enable
        Ch1InputSel1.Enabled = Enable
        Ch1InputSel2.Enabled = Enable
        Ch2InputSel1.Enabled = Enable
        Ch2InputSel2.Enabled = Enable
        TrgSel1.Enabled = Enable
        TrgSel2.Enabled = Enable
        TrgSel3.Enabled = Enable
        TrgSel4.Enabled = Enable
        ThLevel.Enabled = Enable
        NCLevel.Enabled = Enable
        SmplMode1.Enabled = Enable
        SmplMode2.Enabled = Enable
        TotalLeng.Enabled = Enable
        FileConvBtn.Enabled = Enable
        Ch1Only.Enabled = Enable

        If SmplMode1.Checked Then '繰り返しモード
            CycleLeng.Enabled = Enable
            PreTrgLeng.Enabled = False
        Else '連続モード
            CycleLeng.Enabled = False
            PreTrgLeng.Enabled = Enable
        End If
    End Sub

    '変換開始、停止ボタン押下
    ' st -> 0 停止 st -> 1 開始
    Private Sub StartStop(st As Boolean)
        If st Then '開始の場合
            If SamplingStart() Then
                EnableDisableControl(False)
                StartStopBtn.Text = "Stop"
            End If
        Else '停止の場合
            If SamplingStop() Then
                EnableDisableControl(True)
                StartStopBtn.Text = "Start"
                StatusText.Text = ""
            End If
        End If
    End Sub

    Private Sub StartStopBtn_Click(sender As System.Object, e As System.EventArgs) Handles StartStopBtn.Click
        If StartStopBtn.Text = "Start" Then '開始の場合
            StartStop(True)
        Else
            StartStop(False)
        End If
    End Sub

    'トリガボタン押下
    Private Sub TriggerBtn_Click(sender As System.Object, e As System.EventArgs) Handles TriggerBtn.Click
        Dim retErr As Short
        retErr = Tusbadm2_Trigger(DevId)
        If retErr <> 0 Then
            Tusbadm2_ErrorDisp(retErr)
            Me.Hide()
            Exit Sub
        End If
    End Sub

    'ファイル変換機能
    '専用バイナリファイルからカンマ区切りテキスト形式(CSV)に変換
    Private Sub FileConvBtn_Click(sender As System.Object, e As System.EventArgs) Handles FileConvBtn.Click
        Dim ReadFileName As String
        Dim WriteFileName As String
        Dim ReadFile As BinaryReader '読み出しファイルストリーム
        Dim WriteFile As StreamWriter ' 保存ファイルストリーム
        Dim tmpByte As Byte

        Do
            OpenFileDialog1.FileName = ""
            OpenFileDialog1.Title = "バイナリファイル指定"
            OpenFileDialog1.Filter = "バイナリファイル (*.dat)|*.dat"
            If (OpenFileDialog1.ShowDialog() = Windows.Forms.DialogResult.Cancel) Then
                Exit Sub
            End If
        Loop While OpenFileDialog1.FileName = ""
        ReadFileName = OpenFileDialog1.FileName

        Do
            SaveFileDialog1.OverwritePrompt = True
            SaveFileDialog1.FileName = ""
            SaveFileDialog1.Title = "変換先ファイル指定"
            SaveFileDialog1.Filter = "テキスト保存ファイル (*.csv)|*.csv"

            If (SaveFileDialog1.ShowDialog() = Windows.Forms.DialogResult.Cancel) Then
                Exit Sub
            End If
        Loop While SaveFileDialog1.FileName = ""
        WriteFileName = SaveFileDialog1.FileName

        ReadFile = New BinaryReader(File.OpenRead(ReadFileName)) 'ファイルを開く
        If File.Exists(SaveFileDialog1.FileName) Then '既存ファイルチェック
            File.Delete(SaveFileDialog1.FileName)
        End If
        WriteFile = New StreamWriter(File.OpenWrite(WriteFileName)) 'ファイルを開く

        WriteFile.WriteLine("Start date time" & "," & System.DateTime.FromBinary(ReadFile.ReadInt64()).ToString()) '日時
        WriteFile.WriteLine("Channel" & "," & ReadFile.ReadByte().ToString()) 'ch
        WriteFile.WriteLine("Clock select" & "," & IIf(ReadFile.ReadByte() = 0, "Internal", "External")) 'クロック選択
        WriteFile.WriteLine("Dividing rate" & "," & ReadFile.ReadInt32().ToString()) '内部クロック分周率 n=2～5000
        WriteFile.WriteLine("Ch2 clock invert" & "," & IIf(ReadFile.ReadByte() = 0, "Disable", "Enable")) 'Ch2クロック反転　0:なし 1:あり
        WriteFile.WriteLine("Input range" & "," & IIf(ReadFile.ReadByte() = 0, "Unipolar", "Bipolar")) 'レンジ 0:ユニポーラ　1:バイポーラ
        tmpByte = ReadFile.ReadByte() 'トリガ選択 0:外部 1:立ち上がり 2:立下り 3:ソフトウェア
        WriteFile.WriteLine("Trigger select" & "," & IIf(tmpByte = 0, "External", IIf(tmpByte = 1, "Up edge", IIf(tmpByte = 2, "Down edge", "Software"))))
        WriteFile.WriteLine("Trigger threshold" & "," & ReadFile.ReadInt32().ToString()) 'アナログトリガ閾値
        WriteFile.WriteLine("Noise cancel level" & "," & ReadFile.ReadInt32().ToString()) 'ノイズキャンセルレベル
        WriteFile.WriteLine("Sampling mode" & "," & IIf(ReadFile.ReadByte() = 0, "Continuation", "Repeat")) '取り込み動作モード 0:連続 1:リピート
        WriteFile.WriteLine("Sampling length per one trigger" & "," & ReadFile.ReadInt32().ToString()) '1トリガ当たりの取り込み長
        WriteFile.WriteLine("Pre trigger length" & "," & ReadFile.ReadInt32().ToString()) 'プレトリガ長


        Try
            Do
                WriteFile.WriteLine(ReadFile.ReadInt16() And &HFFFS) 'オーバーレンジビットはマスクします
            Loop
        Catch ex As EndOfStreamException
            If Not (TypeOf ex Is EndOfStreamException) Then
                MessageBox.Show(ex.ToString())
            End If
        End Try

        ReadFile.Close()
        WriteFile.Close()

        MessageBox.Show("変換が終了しました")
    End Sub

    'タイマー2の処理
    '変換時の監視
    Private Sub Timer2_Tick(sender As System.Object, e As System.EventArgs) Handles Timer2.Tick
        Dim Status As Byte
        Dim OvfSt As Byte
        Dim Leng(1) As Integer
        Dim UsableRate(1) As Integer
        Dim Data() As Short
        Dim ret As Short
        Dim cnt As Integer

        'ステータスチェック
        If Tusbadm2_Status_Get(DevId, Status, OvfSt) = 0 Then
            Select Case Status
                Case 0 '停止
                    StatusText.Text = ""
                Case 1 'トリガ前
                    StatusText.Text = "Trigger waiting."
                Case 2 'トリガ後
                    Select Case OvfSt
                        Case 1 'ch1オーバフロー
                            StatusText.Text = "Ch1 buffer overflow."
                        Case 2 'ch2オーバフロー
                            StatusText.Text = "Ch2 buffer overflow."
                        Case 3 'ch1とCh2オーバフロー
                            StatusText.Text = "Ch1 && Ch2 buffer overflow."
                        Case Else
                            StatusText.Text = "Sampling"
                    End Select
            End Select
        End If

        'データ取り込み
        If Tusbadm2_Length(DevId, Leng(0), Leng(1), UsableRate(0), UsableRate(1)) = 0 Then

            If (SavedDataNum(0) + Leng(0)) > SmplMaxLeng Then 'Ch1 データが多すぎる場合
                Leng(0) = SmplMaxLeng - SavedDataNum(0)
            End If
            If Leng(0) Then
                ReDim Data(Leng(0) - 1)

                ret = Tusbadm2_Data_Get(DevId, 0, Data, Leng(0))
                If ret = 0 Then
                    For cnt = 0 To (Leng(0) - 1)
                        SaveFile(0).Write(Data(cnt))
                    Next
                End If
            End If
            SavedDataNum(0) = SavedDataNum(0) + Leng(0)

            If Ch1Only.Checked = False Then
                If (SavedDataNum(1) + Leng(1)) > SmplMaxLeng Then 'Ch2 データが多すぎる場合
                    Leng(1) = SmplMaxLeng - SavedDataNum(1)
                End If
                If Leng(1) Then
                    ReDim Data(Leng(1) - 1)

                    ret = Tusbadm2_Data_Get(DevId, 1, Data, Leng(1))
                    If ret = 0 Then
                        For cnt = 0 To (Leng(1) - 1)
                            SaveFile(1).Write(Data(cnt))
                        Next
                    End If
                End If
                SavedDataNum(1) = SavedDataNum(1) + Leng(1)
            End If


            Ch1SampledLeng.Text = SavedDataNum(0).ToString()
            Ch1BufRate.Text = UsableRate(0).ToString("000") & "%"
            Ch2SampledLeng.Text = SavedDataNum(1).ToString()
            Ch2BufRate.Text = UsableRate(1).ToString("000") & "%"

            If Ch1Only.Checked = True Then
                If (SavedDataNum(0) >= SmplMaxLeng) Then
                    StartStop(False) '停止
                End If
            Else
                If (SavedDataNum(0) >= SmplMaxLeng) And (SavedDataNum(1) >= SmplMaxLeng) Then
                    StartStop(False) '停止
                End If
            End If
        End If
    End Sub

End Class